<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="1200px" :close-on-click-modal="false">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogCodeLabel')" prop="code">
        <el-input v-model="formData.code" :placeholder="t('FactoryModeling.ProductBOM.dialogCodePlaceholder')" :disabled = "formType === 'update'"/>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogVersionLabel')" prop="version">
        <el-input v-model="formData.version" :placeholder="t('FactoryModeling.ProductBOM.dialogVersionPlaceholder')" />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogProductLabel')" prop="productId">
        <el-select
          v-model="formData.productId"
          clearable
          filterable
          :placeholder="t('FactoryModeling.ProductBOM.dialogProductPlaceholder')"
          class="!w-1/1"
        >
          <el-option
            v-for="item in productList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogUnitLabel')" prop="unitId">
            <el-select v-model="formData.unitId" clearable :placeholder="t('FactoryModeling.ProductBOM.dialogUnitPlaceholder')" class="w-1/1">
              <el-option
                v-for="unit in unitList"
                :key="unit.id"
                :label="unit.name"
                :value="unit.id"
              />
            </el-select>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogYieldRateLabel')" prop="yieldRate">
        <el-input-number
          v-model="formData.yieldRate"
          :min="0"
          :max="100"
          :precision="2"
          class="!w-1/1"
          :placeholder="t('FactoryModeling.ProductBOM.dialogYieldRatePlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogRemarkLabel')" prop="remark">
        <el-input type="textarea" v-model="formData.remark" :placeholder="t('FactoryModeling.ProductBOM.dialogRemarkPlaceholder')" />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.ProductBOM.dialogEnableLabel')" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <!-- 子表的表单 -->
    <el-tabs v-model="subTabsName">
      <el-tab-pane :label="t('FactoryModeling.ProductBOM.detailTabLabel')" name="bomDetail">
        <BomDetailForm ref="bomDetailFormRef" :bom-id="formData.id" />
      </el-tab-pane>
    </el-tabs>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getBoolDictOptions, DICT_TYPE } from '@/utils/dict'
import { BomApi, BomVO } from '@/api/mes/bom'
import BomDetailForm from './components/BomDetailForm.vue'
import { ProductUnitApi, ProductUnitVO } from '@/api/erp/product/unit'
import { ProductApi, ProductVO } from '@/api/erp/product/product'

const productList = ref<ProductVO[]>([]) // 产品列表
const unitList = ref<ProductUnitVO[]>([]) // 产品单位列表

/** 产品BOM 表单 */
defineOptions({ name: 'BomForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  version: undefined,
  productId: undefined,
  unitId: undefined,
  yieldRate: undefined,
  remark: undefined,
  isEnable: undefined
})
const formRules = reactive({
  code: [{ required: true, message: t('FactoryModeling.ProductBOM.validatorCodeRequired'), trigger: 'blur' }],
  version: [{ required: true, message: t('FactoryModeling.ProductBOM.validatorVersionRequired'), trigger: 'blur' }],
  productId: [{ required: true, message: t('FactoryModeling.ProductBOM.validatorProductRequired'), trigger: 'blur' }],
  unitId: [{ required: true, message: t('FactoryModeling.ProductBOM.validatorUnitRequired'), trigger: 'blur' }],
  isEnable: [{ required: true, message: t('FactoryModeling.ProductBOM.validatorEnableRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 子表的表单 */
const subTabsName = ref('bomDetail')
const bomDetailFormRef = ref()

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await BomApi.getBom(id)
    } finally {
      formLoading.value = false
    }
  }
  if(type==='detail'){

  }
  // 产品单位
  unitList.value = await ProductUnitApi.getProductUnitSimpleList()
  // 加载产品、
  productList.value = await ProductApi.getMesProductSimpleList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 校验子表单
  try {
    await bomDetailFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'bomDetail'
    return
  }
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as BomVO
    // 拼接子表的数据
    data.bomDetails = bomDetailFormRef.value.getData()
    if (formType.value === 'create') {
      await BomApi.createBom(data)
      message.success(t('common.createSuccess'))
    } else {
      await BomApi.updateBom(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    version: '1.0',
    productId: undefined,
    unitId: 5,
    yieldRate: 100,
    remark: undefined,
    isEnable: true
  }
  formRef.value?.resetFields()
}
</script>
